// intraFont Simple
#include <pspkernel.h>
#include <stdio.h>
#include <string.h>
#include <pspgu.h>
#include <pspgum.h>
#include <pspdisplay.h>
#include <time.h>
#include <pspdebug.h>
#include <intraFont.h>

PSP_MODULE_INFO("intraFont Simple", PSP_MODULE_USER, 1, 1);
// 以下4行はguコマンド処理に必要
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
// メインルーチン
int main() {
	pspDebugScreenInit();
	// カラー定義
   	enum colors {
		RED = 0xFF0000FF,GREEN = 0xFF00FF00,BLUE = 0xFFFF0000,WHITE = 0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,GRAY = 0xFF7F7F7F,DARKGRAY = 0xFF3F3F3F,BLACK = 0xFF000000,
	};
	// ltn0～15フォント初期化＆ロード
	pspDebugScreenPrintf("Loading fonts..\n");
	intraFont* ltn[16];
	char file[40];
	int i;
	intraFontInit();
	for (i = 0; i < 16; i++) {
		sprintf(file, "flash0:/font/ltn%d.pgf", i); 
		ltn[i] = intraFontLoad(file,0);
	}
	// 日本語フォントをロード
    intraFont* jpn0 = intraFontLoad("flash0:/font/jpn0.pgf",INTRAFONT_STRING_SJIS);

	// GU初期化
	sceGuInit();
	sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuDepthRange(65535, 0);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0);
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
	while(1){
		// 描画開始
		sceGuStart(GU_DIRECT, list);
		sceGumMatrixMode(GU_PROJECTION);
		sceGumLoadIdentity();
		sceGumPerspective( 75.0f, 16.0f/9.0f, 0.5f, 1000.0f);
        sceGumMatrixMode(GU_VIEW);
		sceGumLoadIdentity();
		sceGumMatrixMode(GU_MODEL);
		sceGumLoadIdentity();
		sceGuClearColor(WHITE); // 背景色
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		// 日本語フォントのみ描画
		intraFontSetEncoding(jpn0, INTRAFONT_STRING_UTF8);
		intraFontPrint(jpn0, 30,30, "ハローワールド");
		// 描画終了
		sceGuFinish();
		sceGuSync(0,0);
		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}
	// 通常は上のループ脱出後にフォントをアンロードするように組む
	for (i = 0; i < 16; i++) {
		intraFontUnload(ltn[i]);
	}
	intraFontUnload(jpn0);
	intraFontShutdown();
	sceKernelExitGame();
	return 0;
}
